﻿-- Author      : Nogarder
-- Create Date : 2012/11/8 12:06:26
NPA_Options.RegisterPageFunc("SpellSelector",function()

	local pairs=pairs
	local CopyTable=CopyTable
	local table_insert=table.insert
	--localization
	local Localization=NPA_Options.Localization.TemplatesWindowSpellSelector
	local Tooltips=Localization.Tooltips
	---
	local parent=NPA_Options.MainFrame
	--
	local main=NPA_Options.Template.CreateFrameWithBar(parent,Localization["SelectSpell"],160,240,nil,nil)
	main:Hide()
	local listeditor=NPA_Options.Template.CreateListEditor(main.Frame,nil,160,240,main,nil)
	listeditor.NoRename=true
	listeditor.NoCopy=true
	listeditor.NoTip=true
	--
	local SpellCatalog
	--script
	local Refresh=function()
		local data={}
		for spellid,spelldata in pairs(NPA_Setting.SpellLib)do
			if(spelldata.Catalog==SpellCatalog)then
				table_insert(data,{
					Text=spelldata.Name,
					Value=spellid,
					TextureFile=spelldata.Icon,
					SquareTexture=true
				})
			end
		end
		NPA_Options.Template.UpdateListEditor(listeditor,data)
	end
	--
	listeditor.RefreshFunc=Refresh
	listeditor.OnCopyFunc=function(oldname,newname)
		NPA_Setting.SpellLib[newname]=CopyTable(NPA_Setting.SpellLib[oldname])
		Refresh()
	end
	listeditor.OnDeleteFunc=function(oldname)
		NPA_Setting.SpellLib[oldname]=nil
		Refresh()
	end
	listeditor.OnRenameFunc=function(oldname,newname)
		NPA_Setting.SpellLib[newname]=CopyTable(NPA_Setting.SpellLib[oldname])
		NPA_Setting.SpellLib[oldname]=nil
		Refresh()
	end
	listeditor.OnCreateFunc=function(newname)
		NPA_Options.SetPage("SpellLookUp",main,newname,function(spellid)
			if(NPA_Setting.SpellLib[spellid])then
				print(Localization["SpellAlreadyExists"])
			else
				local name, _,icon, _,_,_,casttime,minrange,maxrange=GetSpellInfo(spellid)
				NPA_Setting.SpellLib[spellid]={
					Name=name,
					School=0,
					Icon=icon,
					CastTime=casttime,
					MinRange=minrange,
					MaxRange=maxrange,
					CoolDown=0,
					CoolDownStack=0,
					Length=0,
					MaxStack=0,
					Catalog=SpellCatalog,
					Class="None",
					DispelAble=nil,
					PVPLength=0,
					PVPDRType="None",
					CounterSpellLength=0,
				}
				print(Localization["SpellCreated"])
				Refresh()
			end
		end)
	end
	listeditor.ButtonOnEnterFunc=function(self)
		GameTooltip:SetOwner(self,"ANCHOR_RIGHT")
		GameTooltip:AddSpellByID(self.Value)
		GameTooltip:AddLine("Spell id"..": |cff00ff00"..self.Value)
		GameTooltip:Show()
	end
	listeditor.ButtonOnLeaveFunc=function()
		GameTooltip:Hide()
	end
	listeditor.OnClickFunc=function(value,key)
		if(key=="LeftButton")then
			NPA_Options.SetPage("SpellEditor",main,value)
		end
	end

	--
	main.OnSetFunc=function(catalog,spellid)
		SpellCatalog=catalog
		if(spellid)then
			Refresh()
			NPA_Options.Template.SetSelectListFocus(listeditor,spellid)
			NPA_Options.SetPage("SpellEditor",main,spellid)
		end
	end
	----
	NPA_Options.RegisterPage("SpellSelector",main)

end)

