﻿-- Author      : Nogarder
-- Create Date : 2012/4/11 14:54:54
--tooltips uses liner
--global
local table_insert=table.insert
local table_getn=table.getn
local pairs=pairs
local string_len=string.len
local string_sub=string.sub
--list
local NPA_Options_Template_Tooltips_List={}
--create a tooltip
local tooltip=CreateFrame("Frame",nil,NPA_Options.MainFrame)
tooltip:SetFrameLevel(255)
tooltip:SetClampedToScreen(true)
tooltip:Hide()
tooltip.Text={}

local _,fontheight=GameFontNormal:GetFont()

NPA_Options.Template.CreateBackground(tooltip,tooltip,0,0.5)

--border
NPA_Options.Template.CreateLinerBorder(tooltip)
NPA_Options.Template.SetLinerBorderFocus(tooltip,1)

tooltip.Liner=NPA_Options.Template.CreateLiner(
		tooltip,
		{
			Frame=tooltip,
			Anchor="CENTER",
			OffsetX=0,
			OffsetY=0,
			},
		nil,
		scale)
NPA_Options.Template.SetLinerFocus(tooltip.Liner,1)
--struct point={
--		Frame=<frame>,
--		Anchor=<Anchor>,
--		OffsetX=<offsetx>,
--		OffsetY=<offsety>,
--	}
--macro for show tooltip
local NPA_Options_Template_Tooltips_Show=function(parent)
	local data=NPA_Options_Template_Tooltips_List[parent]
	--check text
	if(data.Text==nil)then
		return
	end
	--set text and size
	--break down text
	local lines={}
	local i=1
	local text=data.Text
	local length=string_len(text)
	while(length>50)do
		lines[i]=string_sub(text,1,50)
		text=string_sub(text,51,length)
		i=i+1
		length=string_len(text)
	end
	lines[i]=text
	--create lines
	local maxwidth=0
	for j=1,i do
		if(not tooltip.Text[j])then
			local atext=tooltip:CreateFontString(nil,"OVERLAY")
			atext:SetFont(GameFontNormal:GetFont())
			atext:SetPoint("TOPLEFT",tooltip,"TOPLEFT",3,-3-fontheight*(j-1))
			atext:Show()
			tooltip.Text[j]=atext
		end
		tooltip.Text[j]:SetText(lines[j])
		tooltip.Text[j]:Show()
		local width=tooltip.Text[j]:GetWidth()+3
		if(width>maxwidth)then
			maxwidth=width
		end
	end
	--hide extra
	for j=i+1,table_getn(tooltip.Text)do
		tooltip.Text[j]:Hide()
	end
	--set size
	tooltip:SetWidth(maxwidth)
	tooltip:SetHeight(fontheight*i+6)
	--set position
	--parent
	--tooltip:SetParent(data.Parent)
	--set anchor
	local danchor
	--direction=
	--1=topright
	--2=topleft
	--3=bottomright
	--4=bottomleft
	if(data.Direction==2)then
		danchor="BOTTOMRIGHT"
	elseif(data.Direction==3)then
		danchor="TOPLEFT"
	elseif(data.Direction==4)then
		danchor="TOPRIGHT"
	else
		danchor="BOTTOMLEFT"
	end
	tooltip:ClearAllPoints()
	tooltip:SetPoint(danchor,data.Parent,data.Point.Anchor,data.Point.OffsetX,data.Point.OffsetY)
	--set liner
	tooltip.Liner:SetPoint("CENTER",data.Parent,data.Point.Anchor,0,0)
	tooltip.Liner.EndPoint:SetPoint("CENTER",tooltip,danchor,0,0)
	tooltip.Liner:Show()
	--show
	tooltip:Show()
end
--set
NPA_Options.Template.SetTooltips=function(text,frame,point,direction,parent)
	--direction=
	--1=topright
	--2=topleft
	--3=bottomright
	--4=bottomleft
	--don't check the text anymore as sometime it's needed to be nil
	--if(text==nil or text=="")then
	--	return
	--end
	direction=direction or 1
	if(not point)then
		if(direction==1)then
			point={
					Anchor="TOPRIGHT",
					OffsetX=50,
					OffsetY=50,
				}
		elseif(direction==2)then
			point={
					Anchor="TOPLEFT",
					OffsetX=-50,
					OffsetY=50,
				}
		elseif(direction==3)then
			point={
					Anchor="BOTTOMRIGHT",
					OffsetX=50,
					OffsetY=-50,
				}
		elseif(direction==4)then
			point={
					Anchor="BOTTOMLEFT",
					OffsetX=-50,
					OffsetY=-50,
				}
		end
	end
	--hook script
	if(not NPA_Options_Template_Tooltips_List[frame])then
		frame:HookScript("OnEnter",function(frame)
				NPA_Options_Template_Tooltips_Show(frame)
			end)
		frame:HookScript("OnLeave",function(frame)
				tooltip:Hide()
			end)
	end
	--store tooltips into list
	NPA_Options_Template_Tooltips_List[frame]={
		Text=text,
		Point=point,
		Direction=direction,
		Parent=parent or frame
	}
end
